//+------------------------------------------------------------------+
//|                                                 OpeningTimes.mq5 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property library
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#define OneDay             86400

//+------------------------------------------------------------------+
//| returns Next Opening and Closing Times                           |
//+------------------------------------------------------------------+
void GetOpeningTimes(string m_Symbol, datetime &m_OpenTime, datetime &m_CloseTime, datetime m_FromTime = NULL)
 {
     datetime m_time = m_FromTime;
     if (m_time == NULL)m_time = TimeTradeServer();
     
     string m_DateStr, m_TimeStr;
     m_DateStr = TimeToString(m_time, TIME_DATE);
     
     MqlDateTime m_TimeStruct, m_OpenStruct, m_CloseStruct;
     TimeToStruct(m_time,m_TimeStruct);
     
     m_OpenTime = NULL; m_CloseTime = NULL;
      
     int m_DayofWeek =  m_TimeStruct.day_of_week;
     for (int x = 0; x<7; x++)
     {
         datetime m_tempOpen;
         datetime m_tempClose;
         
         SymbolInfoSessionTrade(m_Symbol,(ENUM_DAY_OF_WEEK)  m_DayofWeek,0, m_tempOpen, m_tempClose);
         TimeToStruct(m_tempOpen, m_OpenStruct);
         TimeToStruct(m_tempClose, m_CloseStruct);
         
         if (m_OpenTime == NULL)
         {
            if (m_OpenStruct.hour > 0 || m_OpenStruct.min > 0)
            {
               m_DateStr = TimeToString(m_time+(OneDay*x), TIME_DATE);
               m_TimeStr = (string)m_OpenStruct.hour + ":"+ (string)m_OpenStruct.min+":"+(string)m_OpenStruct.sec;
               m_OpenTime = StringToTime(m_DateStr+" "+m_TimeStr);
            }
         }
         
         if (m_CloseTime == NULL)
         {
            if (m_CloseStruct.hour > 0 || m_CloseStruct.min > 0)
            {
               m_DateStr = TimeToString(m_time+(OneDay*x), TIME_DATE);
               m_TimeStr = (string)m_CloseStruct.hour + ":"+ (string)m_CloseStruct.min+":"+(string)m_CloseStruct.sec;
               m_CloseTime = StringToTime(m_DateStr+" "+m_TimeStr);
            }
         }
         if (m_OpenTime != NULL && m_CloseTime != NULL)return;
         m_DayofWeek++;
         if (m_DayofWeek > 6)m_DayofWeek = 0;
     }
 return;
 }
